// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js

if (![].includes) {
  Array.prototype.includes = function(searchElement) {
    for (var e in this) {
      if (this[e] === searchElement) {
        return true;
      }
    }
    return false;
  };
}
if (![].moveToFirst) {
  Array.prototype.moveToFirst = function(index) {
    if (index >= this.length) {
      return this;
    }
    this.splice(0, 0, this.splice(index, 1)[0]);
    return this;
  };
}

var module = angular.module('premieroutlet', ['ionic', 'premieroutlet.controllers', 'premieroutlet.services', 'ngOpenFB', 'ngGooglePlusAuth']);

module.constant('VERSION', '1.1');
module.constant('DESKTOPTEST', false);
module.constant('FACEBOOK_APP_ID', '566813963395837');
module.constant('GOOGLE_OAUTH_CLIENT_ID', '384798741109-tta8vuckgoupadb76hefhgr1ph88297t.apps.googleusercontent.com');
module.constant('GOOGLE_OAUTH_CLIENT_SECRET', 'zTqzxb2mYoCYWp27W6rTsxiM');
module.constant('GOOGLE_PROJECT_NUMBER', '384798741109');
module.constant('ANALYTICS_ID', 'UA-11170322-2');
module.constant('SYNC_INTERVAL', 1000 * 60 * 60 * 24);

module.run(function($ionicPlatform, $rootScope, $state, $ionicHistory, $ionicLoading, $ionicPopup, $log,
                    Config, UserConfig, DataLoaderService, ListBuilderService, NotificationService, FavouritesService,
                    GeneralRemoteDb, UserdataRemoteDb,
                    CouponDAO, OfferDAO, ShopDAO,
                    ngFB, ngGP,
                    FACEBOOK_APP_ID, GOOGLE_OAUTH_CLIENT_ID, GOOGLE_OAUTH_CLIENT_SECRET, GOOGLE_PROJECT_NUMBER, ANALYTICS_ID) {

  var syncInProgress = false;
  var loginInProgress = false;

  var facebookLogin = function(event) {
    loginInProgress = true;
    if (window.analytics) {
      window.analytics.trackEvent('user_action', 'social_login', 'Facebook', 0);
    }

    var errorCatcher = function(error) {
      $log.error('Facebook login error: ' + JSON.stringify(error));
      if (window.analytics) {
        window.analytics.trackException('Facebook login error: ' + JSON.stringify(error), false);
      }
      loginInProgress = false;
      hideProgressPopup();
      $ionicPopup.alert({
        title: 'Regisztráció hiba',
        template: error + '<br/><br/>Próbálkozz később újra és ha továbbra sem sikerül, frissítsd az alkalmazást!'
      });
    };

    FavouritesService.fbLogin().then(function(response) {
      showLoginProgressPopup();

      var measuredTimeStart = new Date().getTime();
      FavouritesService.fbSaveLoginData(response.authResponse.accessToken).then(function() {
        if (window.analytics) {
          window.analytics.trackTiming('Login', new Date().getTime() - measuredTimeStart, 'Facebook', 'Facebook');
        }
        var user = UserConfig.getData();
        if (user) {
          event.targetScope.user = user;
          if (window.analytics) {
            window.analytics.setUserId(user._id);
          }
          NotificationService.init(function (msg) {
            $ionicPopup.alert({
              title: 'Újdonságok',
              template: msg,
            }).then(function (res) {
              $state.go('tab.reminders');
            });
          });
        }
        loginInProgress = false;
        hideProgressPopup();
        if (syncInProgress) {
          showSyncProgressPopup();
        }
      }).catch(errorCatcher);
    }).catch(errorCatcher);
  };

  var googleplusLogin = function(event) {
    loginInProgress = true;

    var errorCatcher = function(error) {
      $log.error('GooglePlus login error: ' + JSON.stringify(error));
      if (window.analytics) {
        window.analytics.trackException('GooglePlus login error: ' + JSON.stringify(error), false);
      }
      loginInProgress = false;
      hideProgressPopup();
      $ionicPopup.alert({
        title: 'Regisztráció hiba',
        template: error + '<br/><br/>Próbálkozz később újra és ha továbbra sem sikerül, frissítsd az alkalmazást!'
      });
    };

    FavouritesService.gpLogin().then(function(result) {
      showLoginProgressPopup();
      $log.debug('Access token: ' + result.access_token);
      FavouritesService.gpSaveLoginData(result.access_token).then(function () {

        var user = UserConfig.getData();
        if (user) {
          event.targetScope.user = user;
          if (window.analytics) {
            window.analytics.setUserId(user._id);
          }
          NotificationService.init(function (msg) {
            $ionicPopup.alert({
              title: 'Újdonságok',
              template: msg,
            }).then(function (res) {
              $state.go('tab.reminders');
            });
          });
        }
        loginInProgress = false;
        hideProgressPopup();
        if (syncInProgress) {
          showSyncProgressPopup();
        }
      }).catch(errorCatcher);
    }).catch(errorCatcher);
  };

  var ownLogin = function(event) {
    loginInProgress = true;
    //alert('data: ' + JSON.stringify($scope.userdata));

    var errorCatcher = function(error) {
      $log.error('Own login error: ' + JSON.stringify(error));
      if (window.analytics) {
        window.analytics.trackException('Own login error: ' + JSON.stringify(error), false);
      }
      loginInProgress = false;
      hideProgressPopup();
      $ionicPopup.alert({
        title: 'Regisztráció',
        template: 'A regisztráció sikertelen volt. Próbálkozz később újra!'
      });
    };

    showLoginProgressPopup();
    FavouritesService.ownLogin(event.targetScope.userdata).then(function() {
      var user = UserConfig.getData();
      if (user) {
        if (window.analytics) {
          window.analytics.setUserId(user._id);
        }
        NotificationService.init(function (msg) {
          $ionicPopup.alert({
            title: 'Újdonságok',
            template: msg,
          }).then(function (res) {
            $state.go('tab.reminders');
          });
        });
      }
      loginInProgress = false;
      hideProgressPopup();
      if (syncInProgress) {
        showSyncProgressPopup();
      }
      $state.go('tab.favorites');

    }).catch(errorCatcher);
  };

  ngFB.init({
    appId: FACEBOOK_APP_ID,
    cordovaOAuthRedirectURL: 'http://www.premieroutlet.hu/mobile/facebookAuthSuccess'
  });

  ngGP.init(GOOGLE_OAUTH_CLIENT_ID, GOOGLE_OAUTH_CLIENT_SECRET);

  var initNotifications = function() {
    NotificationService.init(function(msg) {
      $log.info('Notification received');
      $ionicPopup.alert({
        title: 'Újdonságok',
        template: msg,
      }).then(function(res) {
        $state.go('tab.reminders');
      });
    });
  };

  var showSyncProgressPopup = function() {
    $ionicLoading.show({
      template: 'Helló, ez a Premier Outlet app!<br/><br/>Szenzációs kuponok és ajánlatok letöltése folyamatban...<br/><br/><ion-spinner icon="spiral" />'
    });
  };

  var showLoginProgressPopup = function() {
    $ionicLoading.show({
      template: 'Regisztráció befejezése<br/><br/><ion-spinner icon="spiral" />'
    });
  };

  var hideProgressPopup = function() {
    $ionicLoading.hide();
  };

  var showRegistrationPopup = function() {
    var regPopup = null;

    var $regScope = $rootScope.$new(true);
    $regScope.closeRegPopup = function() {
      if (regPopup != null) {
        regPopup.close();
      }
      $regScope.$destroy();
      if (syncInProgress) {
        showSyncProgressPopup();
      }
    };
    $regScope.fbLogin = function() {
      $regScope.closeRegPopup();
      $rootScope.$broadcast('fbLogin');
    };
    $regScope.gpLogin = function() {
      $regScope.closeRegPopup();
      $rootScope.$broadcast('gpLogin');
    };
    $regScope.ownLogin = function() {
      $regScope.closeRegPopup();
      $state.go('tab.login');
    };

    regPopup = $ionicPopup.show({
      templateUrl: 'templates/registration-popup.html',
      cssClass: 'registration-popup-container',
      scope: $regScope
    });
  };

  var errorCatcher = function(error) {
    $log.error('Data load error: ' + JSON.stringify(error));
    hideProgressPopup();
    $ionicPopup.alert({
      title: 'Adatbetöltési hiba',
      template: 'Hiba történt az adatok betöltése közben (' + error.message + ').<br/><br/>Próbáld később újra!<br/><br/>Internetkapcsolat szükséges!'
    });
  };

  var initAnalytics = function() {
    if (window.analytics) {
      window.analytics.startTrackerWithId(ANALYTICS_ID);
      $log.info('GA tracking started');
    }
    else {
      $log.warn("GA tracking unavailable");
    }
  };

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }

    $rootScope.goBack = function() {
      $ionicHistory.goBack(1);
    };

    initAnalytics();

    Config.load().then(function() {
      $log.debug('Config loaded');
      GeneralRemoteDb.init();
      UserdataRemoteDb.init();

      $rootScope.$on('fbLogin', facebookLogin);
      $rootScope.$on('gpLogin', googleplusLogin);
      $rootScope.$on('ownLogin', ownLogin);

      ShopDAO.count().then(function(shopCount) {
        $log.debug('Shops counted');
        if (shopCount == 0) {
          showRegistrationPopup();
          syncInProgress = true;
          var measuredTimeStart = new Date().getTime();
          DataLoaderService.syncEverything(true).then(function() {
            syncInProgress = false;
            if (window.analytics) {
              window.analytics.trackTiming('BackendSync', new Date().getTime() - measuredTimeStart, 'everything', 'Minden adat frissítése');
            }
            if (!loginInProgress) {
              hideProgressPopup();
            }
            ListBuilderService.buildValidCouponsList().then(function(couponList) {
              $rootScope.$broadcast('setCouponListEvent', couponList);
            }).catch(errorCatcher);
          }).catch(errorCatcher);
        }
        else {
          ListBuilderService.buildValidCouponsList().then(function(couponList) {
            $rootScope.$broadcast('setCouponListEvent', couponList);
            if (UserConfig.getId()) {
              if (window.analytics) {
                window.analytics.setUserId(UserConfig.getId());
              }
              initNotifications();
            }
            else {
              showRegistrationPopup();
            }
            syncInProgress = true;
            var measuredTimeStart = new Date().getTime();
            DataLoaderService.syncEverything().then(function(changeCount) {
              syncInProgress = false;
              if (changeCount > 0) {
                if (window.analytics) {
                  window.analytics.trackTiming('BackendSync', new Date().getTime() - measuredTimeStart, 'everything', 'Minden adat frissítése');
                }
                if (!loginInProgress) {
                  hideProgressPopup();
                }
                ListBuilderService.buildValidCouponsList().then(function(couponList) {
                  $rootScope.$broadcast('setCouponListEvent', couponList);
                }).catch(errorCatcher);
              }
            }).catch(errorCatcher);
          }).catch(errorCatcher);
        }
      });
    }).catch(function(error) {
      $log.error('config load error: ' + JSON.stringify(error));
    });


  });
});


module.controller('MainController', ['$scope', '$rootScope', function($scope, $rootScope) {
  $rootScope.openInBrowser = function(url) {
    window.open(encodeURI(url), '_system');
  }

}]);



module.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider.state('tab', {
    url: "/tab",
    abstract: true,
    templateUrl: "templates/tabs.html"
  });

  $stateProvider.state('tab.coupons', {
    url: '/coupons',
    views: {
      'tab-coupons': {
        templateUrl: 'templates/tab-coupons.html',
        controller: 'CouponsCtrl'
      }
    }
  });

  $stateProvider.state('tab.coupons-details', {
    url: '/coupons/:couponId',
    views: {
      'tab-coupons': {
        templateUrl: 'templates/coupon-detail.html',
        controller: 'CouponDetailCtrl'
      }
    }
  });

  $stateProvider.state('tab.similar-coupons', {
    url: '/coupons/:couponId/similar',
    views: {
      'tab-coupons': {
        templateUrl: 'templates/similar-coupons.html',
        controller: 'CouponSimilarCtrl'
      }
    }
  });

  $stateProvider.state('tab.offers', {
    url: '/offers',
    views: {
      'tab-offers': {
        templateUrl: 'templates/tab-offers.html',
        controller: 'OffersCtrl'
      }
    }
  });

  $stateProvider.state('tab.offers-details', {
    url: '/offers/:offerId',
    views: {
      'tab-offers': {
        templateUrl: 'templates/offer-detail.html',
        controller: 'OfferDetailCtrl'
      }
    }
  });

  $stateProvider.state('tab.similar-offers', {
    url: '/offers/:offerId/similar',
    views: {
      'tab-offers': {
        templateUrl: 'templates/similar-offers.html',
        controller: 'OfferSimilarCtrl'
      }
    }
  });

  $stateProvider.state('tab.shops', {
    url: '/shops',
    views: {
      'tab-shops': {
        templateUrl: 'templates/tab-shops.html',
        controller: 'ShopsCtrl'
      }
    }
  });

  $stateProvider.state('tab.shops-details', {
    url: '/shops/:shopId',
    views: {
      'tab-shops': {
        templateUrl: 'templates/shop-detail.html',
        controller: 'ShopDetailCtrl'
      }
    }
  });

  $stateProvider.state('tab.similar-shops', {
    url: '/shops/:shopId/similar',
    views: {
      'tab-shops': {
        templateUrl: 'templates/similar-shops.html',
        controller: 'ShopSimilarCtrl'
      }
    }
  });

  $stateProvider.state('tab.favorites', {
    url: '/favorites',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/tab-favorites.html',
        controller: 'FavoritesCtrl'
      }
    }
  });

  $stateProvider.state('tab.favorite-shops', {
    url: '/favorites/shops',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/tab-favorite-shops.html',
        controller: 'FavoriteShopsCtrl'
      }
    }
  });

  $stateProvider.state('tab.favorite-products', {
    url: '/favorites/products',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/tab-favorite-products.html',
        controller: 'FavoriteProductsCtrl'
      }
    }
  });

  $stateProvider.state('tab.favorite-coupons', {
    url: '/favorites/coupons',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/tab-favorites-coupons.html',
        controller: 'FavoriteCouponsCtrl'
      }
    }
  });

  $stateProvider.state('tab.reminders', {
    url: '/favorites/reminders',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/tab-favorites-reminders.html',
        controller: 'RemindersCtrl'
      }
    }
  });

  $stateProvider.state('tab.reminder-details', {
    url: '/messages/:messageId',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/reminder-detail.html',
        controller: 'ReminderDetailCtrl'
      }
    }
  });

  $stateProvider.state('tab.login', {
    url: '/favorites/login',
    views: {
      'tab-favorites': {
        templateUrl: 'templates/tab-login.html',
        controller: 'LoginCtrl'
      }
    }
  });

  $stateProvider.state('info', {
    url: '/info',
    templateUrl: 'templates/info.html',
    controller: function($scope, $log, $sce, Config, ContentService) {
      Config.load().then(function() {
        ContentService.getInfoContent().then(function (doc) {
          $scope.content = $sce.trustAsHtml(doc.content);
        }).catch(function (error) {
          $log.error('info getInfoContent error: ' + JSON.stringify(error));
        });
      }).catch(function(error) {
        $log.error('info config load error: ' + JSON.stringify(error));
      });
    }
  });


  $urlRouterProvider.otherwise('/tab/coupons');

});


module.config(function($httpProvider, $logProvider) {
  //Enable cross domain calls
  $httpProvider.defaults.useXDomain = true;
  $logProvider.debugEnabled(true);
});


module.filter('formatDate', function() {
  return function(date, suffix) {
    date = date || '';
    var m = moment(date, 'YYYY-MM-DD');
    if (!m.isValid()) {
      m = moment(date, 'X');
    }
    if (m.isValid()) {
      var fd = m.locale('hu').format('MMMM D');
      var dd = m.format('D');
      switch (suffix) {
        case 'from':
          switch (parseInt(dd[dd.length - 1])) {
            case 0:
              if (dd == 10) {
                return fd + '-től';
              }
              return fd + '-tól';
              break;
            case 1:
            case 2:
            case 4:
            case 5:
            case 7:
            case 9:
              return fd + '-től';
              break;
            case 3:
            case 6:
            case 8:
              return fd + '-tól';
              break;
            default:
              return fd;
              break;
          }
          break;
        case 'to':
          return fd + '-ig';
          break;
        default:
          return fd;
          break;
      }
    }
    return date;
  };
});
