var GooglePlusAuth = (function () {

  var login_url = 'https://accounts.google.com/o/oauth2/auth?';

  var client_id;
  var client_secret;
  var redirect_uri = 'http://www.premieroutlet.hu/mobile/googleplusTokenResult';//urn:ietf:wg:oauth:2.0:oob';//http://localhost';//
  var response_type = 'code';
  var scope = 'profile email';

  var runningInCordova = false;
  var loginProcessed = false;

  document.addEventListener("deviceready", function () {
    runningInCordova = true;
  });


  function init(c_id, c_secret) {
    client_id = c_id;
    client_secret = c_secret;
  }

  function parseQueryString(queryString) {
    var qs = decodeURIComponent(queryString);
    var obj = {};
    var params = qs.split('&');

    params.forEach(function (param) {
      var splitter = param.split('=');
      obj[splitter[0]] = splitter[1];
    });
    return obj;
  }

  /*
  function oauthCallback(url, success_callback, error_callback) {
    // Parse the OAuth data received from Facebook
    var queryString;
    var obj;

    loginProcessed = true;
    if (url.indexOf("access_token=") > 0) {
      queryString = url.substr(url.indexOf('#') + 1);
      obj = parseQueryString(queryString);
      if (success_callback) {
        success_callback({
          status: 'connected',
          authResponse: {
            accessToken: obj['access_token']
          }
        });
      }
    }
    else if (url.indexOf("error=") > 0) {
      queryString = url.substring(url.indexOf('?') + 1, url.indexOf('#'));
      obj = parseQueryString(queryString);
      if (error_callback) {
        error_callback({
          status: 'not_authorized',
          error: obj.error
        });
      }
    }
    else {
      if (error_callback) {
        error_callback({
          status: 'not_authorized'
        });
      }
    }
  }
  */


  function getAccessToken(code, success_callback, error_callback) {
    console.log('Now retrieving access code');

    var tokenUrl = 'https://accounts.google.com/o/oauth2/token';
    var data = 'code=' + encodeURIComponent(code) + '&client_id=' + client_id + '&client_secret=' + client_secret + '&redirect_uri=' + encodeURIComponent('http://www.premieroutlet.hu/mobile/googleplusTokenResult') + '&grant_type=authorization_code';

    console.log('TOKEN URL: ' + tokenUrl);
    console.log('TOKEN DATA: ' + data);

    var xhr = new XMLHttpRequest();
    xhr.open('POST', tokenUrl, true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.onload = function() {
      console.log('logged in');
      console.log(xhr.responseText);
      if (xhr.status == 200) {
        success_callback(JSON.parse(xhr.responseText));
      }
      else {
        error_callback('Bejelentkezés sikertelen.');
      }
    };
    xhr.onreadystatechange = function() {
      console.log('STATE CHANGED: ' + JSON.stringify(xhr));
    };
    //console.log('user=' + encodeURIComponent(jsonUser));
    console.log('Posting request to get access token');
    xhr.send(data);
  };


  function login(success_callback, error_callback) {
    var loginWindow;
    var startTime;
    var loginUrl = login_url + 'client_id=' + client_id + '&redirect_uri=' + encodeURIComponent(redirect_uri) + '&response_type=code&scope=' + encodeURIComponent(scope);


    function loadStartHandler(event) {
      console.log('handling onLoadStop');

      var url = event.url;
      console.log('URL: ' + url);
      var baseUrl = url.substring(0, url.indexOf('?'));
      console.log('L BASE URL: ' + baseUrl);

      if (baseUrl == redirect_uri) {

        var queryString = url.substring(url.indexOf('?') + 1);
        var params = parseQueryString(queryString);
        console.log('PARAMS: ' + JSON.stringify(params));

        var code = params.code;

        console.log('CODE: ' + code);
        if (code) {
          loginProcessed = true;
          getAccessToken(code, success_callback, error_callback);
          loginWindow.close();
        }
        else {
          loginWindow.close();
          error_callback('Nem érkezett kód a Google-től a bejelentkezéshez.');
        }
      }
    };

    /*
    function loadStopHandler(event) {
      console.log('handling onLoadStop');

      var url = event.url;
      var baseUrl = url.substring(0, url.indexOf('?'));
      console.log('L BASE URL: ' + baseUrl);

      if (baseUrl == 'https://accounts.google.com/o/oauth2/approval') {

        loginWindow.executeScript({
          code: "document.getElementById('code').value;"
        }, function(result) {
          var code = result[0];
          console.log('CODE: ' + code);
          loginWindow.close();

          if (code) {
            getAccessToken(code, success_callback, error_callback);
          }
          else {
            error_callback('Nem érkezett kód a Google-től a bejelentkezéshez.');
          }

        });
      }
    };
    */


    function exitHandler() {
      if (error_callback && !loginProcessed) {
        error_callback({
          status: 'user_cancelled'
        });
      }
      loginWindow.removeEventListener('loadstart', loadStartHandler);
      //loginWindow.removeEventListener('loadstop', loadStopHandler);
      loginWindow.removeEventListener('exit', exitHandler);
      loginWindow = null;
      console.log('done removing listeners');
    };

    console.log('URL: ' + loginUrl);
    startTime = new Date().getTime();
    loginWindow = window.open(loginUrl, '_blank', 'location=no,clearcache=yes');
    console.log('running in cordova: ' + runningInCordova);
    if (runningInCordova) {
      console.log('attaching event handlers to login window');
      loginWindow.addEventListener('loadstart', loadStartHandler);
      //loginWindow.addEventListener('loadstop', loadStopHandler);
      loginWindow.addEventListener('exit', exitHandler);
    }
  }

  return {
    init: init,
    login: login
  }

}());

angular.module('ngGooglePlusAuth', [])
  .factory('ngGP', function ($q, $window) {

    function init(c_id, c_secret) {
      $window.GooglePlusAuth.init(c_id, c_secret);
    }

    function login() {
      var deferred = $q.defer();
      $window.GooglePlusAuth.login(function(result) {
        deferred.resolve(result);
      }, function(error) {
        deferred.reject(error);
      });
      return deferred.promise;
    }

    return {
      init: init,
      login: login
    };

  });


